<template>
  <v-list v-if="track" nav dense>
    <reset-sync-button @reset-unit="emitResetUnit" />
    <sync-nav-list
      :piece="piece"
      :is-minified="isMinified"
    />
    <upload-sync-button
      v-if="piece && canUploadSync"
      :client="client"
      :path="uploadPath"
      :unit="unit"
      @saved="isClean = true"
    />
    <export-sync-button
      :clean.sync="isClean"
      :piece-path="piece.path"
      :unit="unit"
    />
    <import-sync-button
      @replace-unit="emitReplaceUnit"
    />
    <piece-analysis-button />
  </v-list>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, PropSync, Watch,
} from 'vue-property-decorator';
import type {
  Audio, EditableUnit, Piece, UnitTable,
} from '@/data';
import type { Client } from '@/client';
import PieceAnalysisButton from '@/components/navigation/buttons/PieceAnalysisButton.vue';
import ExportSyncButton from './ExportSyncButton.vue';
import ImportSyncButton from './ImportSyncButton.vue';
import ResetSyncButton from './ResetSyncButton.vue';
import SyncNavList from './SyncNavList.vue';
import UploadSyncButton from './UploadSyncButton.vue';

@Component({
  components: {
    ExportSyncButton,
    ImportSyncButton,
    ResetSyncButton,
    SyncNavList,
    UploadSyncButton,
    PieceAnalysisButton,
  },
})
export default class SyncSidebarItems extends Vue {
  @Prop({ required: true })
  client!: Client;

  @Prop({ required: true })
  piece!: Piece;

  @Prop({ required: true })
  unit!: EditableUnit | null;

  @PropSync('clean')
  isClean!: boolean;

  @Prop()
  isMinified!: boolean;

  @Prop()
  track!: Audio;

  canUploadSync = false;

  mounted() {
    this.canUpload();
  }

  @Watch('piece')
  canUpload() {
    if (this.piece && this.client.user) {
      this.canUploadSync = this.piece.can('update-synchro');
    } else {
      this.canUploadSync = false;
    }
  }

  get uploadPath(): string | null {
    if (this.track.url) {
      const trackUrlSplit = this.track.url.split('/');
      return `${this.piece.path}/sources/audios/${trackUrlSplit[trackUrlSplit.length - 2]}`;
    }
    return null;
  }

  emitResetUnit() {
    this.$emit('reset-unit');
  }

  emitReplaceUnit(table: UnitTable) {
    this.$emit('replace-unit', table);
  }
}
</script>
